# -*- coding: utf-8 -*-
# Generated by Django 1.11.10 on 2018-03-07 17:31
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Activitat',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(blank=True, max_length=100)),
                ('ponderacio', models.IntegerField(default=0)),
                ('avaluable', models.BooleanField(default=True)),
            ],
        ),
        migrations.CreateModel(
            name='Alumne',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(blank=True, max_length=100)),
                ('congnom_1', models.CharField(blank=True, max_length=100)),
                ('congnom_2', models.CharField(blank=True, max_length=100)),
            ],
        ),
        migrations.CreateModel(
            name='Assignatura',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(blank=True, max_length=100)),
            ],
        ),
        migrations.CreateModel(
            name='Centre',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(default='', max_length=100)),
                ('ubicacio', models.CharField(default='', max_length=100)),
            ],
        ),
        migrations.CreateModel(
            name='Curs',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(blank=True, max_length=100)),
                ('nivell', models.CharField(choices=[('eso', 'ESO'), ('batxillerat', 'Batxillerat')], max_length=15)),
            ],
        ),
        migrations.CreateModel(
            name='Professor',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('nom', models.CharField(blank=True, max_length=100)),
                ('congnom_1', models.CharField(blank=True, max_length=100)),
                ('congnom_2', models.CharField(blank=True, max_length=100)),
                ('email', models.CharField(blank=True, max_length=100)),
                ('data_naixement', models.DateField()),
                ('password', models.CharField(blank=True, max_length=100)),
            ],
        ),
        migrations.CreateModel(
            name='Qualificacio',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('qualificacio', models.IntegerField(default=0)),
                ('activitat', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='quickstart.Activitat')),
                ('alumne', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='quickstart.Alumne')),
            ],
        ),
        migrations.AddField(
            model_name='centre',
            name='professor',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='alta', to='quickstart.Professor'),
        ),
        migrations.AddField(
            model_name='assignatura',
            name='centre',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='assignatura_centre', to='quickstart.Centre'),
        ),
        migrations.AddField(
            model_name='assignatura',
            name='curs',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='assignatura_curs', to='quickstart.Curs'),
        ),
        migrations.AddField(
            model_name='alumne',
            name='centre',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='alumne_centre', to='quickstart.Centre'),
        ),
        migrations.AddField(
            model_name='alumne',
            name='curs',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='alumne_curs', to='quickstart.Curs'),
        ),
        migrations.AddField(
            model_name='activitat',
            name='assignatura',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='activitat_assignatura', to='quickstart.Assignatura'),
        ),
    ]
